<?php
/*
Plugin Name: Description for Facebook
Plugin URI: http://www.marktheweb.it/blog/enligh-explanation-to-description-for-facebook.php
Description: Just a simple plugin to customize the meta-tag description for Facebook crawler.
Author: Marco Antonutti
Version: 1.0b
Author URI: http://www.marktheweb.it/
*/
function fb_description_config_page(){
//just add the info (or in the future option) page
  if (function_exists('add_options_page')){
    add_options_page('Description For Facebook', 
                     'Description For Facebook',
                     8,
                     basename(__FILE__),
                     'fb_plugin_config'
                     );
  }
}

/* Function for admin Panel */
function fb_plugin_config(){
//THERE ARE NOT any functions, is just to explain to dummy wp webmaster what the plugin is for.
?>
<div class="wrap">
         <h2>Meta Description for Facebook</h2>
	          Did you know which words are more effective in order to  improve your facebook engagement?<br/>
			  The BuddyMedia study has done the work for us:<br/>
			  <img src="<?php bloginfo('url'); ?>/wp-content/plugins/description-for-facebook/like-vs-comment.jpg" alt="Best words for improve fb engagement"/><br/>
			  Do you use them in your meta description? Usually you don't, i guess/hope. Description for Facebook help you doing this, automatically recognizing the fb crawler and writing a different (and i hope optimized) description.<br/>
			  <strong>Enjoy this plugin!</strong>
			  Want to tell me you love my work?  <a href="http://www.marktheweb.it/blog/enligh-explanation-to-description-for-facebook.php" target="_blank">visit the plugin page</a> on my blog and wrote to me!
			
			  ps: you don't need any options page. Just go to add/edit a post/page and have fun.
         </div>
		 <?php
}


function fb_desc_admin_post() {
//call to the box, i no longer offer solutions for wp version < 2.5.
	if ( function_exists( 'add_meta_box' )) {
    add_meta_box( 'fb_desc_div','Description For Facebook', 'fb_desc_inner_box', 'post', 'advanced' );
    add_meta_box( 'fb_desc_div','Description For Facebook', 'fb_desc_inner_box', 'page', 'advanced' );
	}
}
function fb_desc_inner_box($post) {
  echo '<label for="desc_fb_field">Insert here your meta description optimized for facebook. It will be shown only to FB crawler.</label>';
     
  echo '<br/> ';
  echo '<textarea name="fb_description" id="desc_fb_field_'.$post->ID.'" style="width:100%;" rows="4">'. get_post_meta($post->ID, "_fb_desc", true).'</textarea>';
  echo '<br/><br/>Check this box if you are updating the fb description and you want Facebook to refresh the Cache. <input type="checkbox" name="update_fb_cache" value="sure"/>';
  echo '<input type="hidden" name="fb_desc_id" value="'.$post->ID.'" />';
}
function fb_desc_savedata($post_id) {

	$postID = $_POST["fb_desc_id"];
	
  $fb_desc = $_POST['fb_description'];
  
  if(get_post_meta($postID,"_fb_desc"))
  delete_post_meta($postID,"_fb_desc");
  
  	 add_post_meta($postID,"_fb_desc", $fb_desc, true);
	 
	 	if($_POST['update_fb_cache'] == 'sure'):
	$url = get_permalink();
	refreshFacebookCache($url);
	endif;
}



function print_desc_for_fb() {
if(is_singular()) {
$post_id =get_the_ID();
$fb_desc = htmlentities(get_post_meta($post_id, "_fb_desc", true));
//we could have done a very great function in order to override the header. But fb crawler take the last description in the header for the only one to display, so don't care about the w3c standard (nobody but facebook will see 2 desc.) and put two description.
if($fb_desc == null) {
	return false;
}

$checkFB = strpos($_SERVER['HTTP_USER_AGENT'], 'http://www.facebook.com/externalhit_uatext.php');

if($checkFB) {
echo '<meta name="description" content="'.$fb_desc.'"/> ';
echo '<meta property="og:description" content="'.$fb_desc.'" /> ';	
}
}
}
function refreshFacebookCache($url) {
$url = urlencode($url);
$connect = fopen('http://developers.facebook.com/tools/lint/?url='.$url, 'r');
}

function fb_desc_install(){
//we don't need at the moment any registration option
}


if (isset($_GET['activate']) && $_GET['activate'] == 'true') {
	fb_desc_install();
}

//hook for the menu
add_action('admin_menu', 'fb_description_config_page');
//hook for the box in the post add/edit page
add_action('admin_init', 'fb_desc_admin_post', 1 );
//hook for the post saving
add_action('save_post', 'fb_desc_savedata');

add_action('wp_head','print_desc_for_fb', 99999);
?>